1. knife-cookbook-site(1)
2. Chef Manual
3. knife-cookbook-site(1)

## NAME

`knife-cookbook-site` - Install and update open source cookbooks

## SYNOPSIS

knife cookbook site sub-command (options)

## COOKBOOK SITE SUB-COMMANDS

`knife cookbook site` provides the following subcommands:

## INSTALL

cookbook site install COOKBOOK [VERSION] (options)

`-D`, `--skip-dependencies`
  Skip automatic installation of dependencies.
`-o`, `--cookbook-path PATH`
  Install cookbooks to PATH
`-B`, `--branch BRANCH`
  Default branch to work with [defaults to master]

Uses git(1) version control in conjunction with the cookbook site to install community contributed cookbooks to your local cookbook repository. Running `knife cookbook site install` does the following:

1. A new "pristine copy" branch is created in git for tracking the upstream;
2. All existing cookbooks are removed from the branch;
3. The cookbook is downloaded from the cookbook site in tarball form;
4. The downloaded cookbook is untarred, and its contents commited via git;
5. The pristine copy branch is merged into the master branch.

By installing cookbook with this process, you can locally modify the upstream cookbook in your master branch and let git maintain your changes as a separate patch. When an updated upstream version becomes available, you will be able to merge the upstream changes while maintaining your local modifications.

Unless --skip-dependencies is specified, the process is applied recursively to all the cookbooks COOKBOOK depends on (via metadata dependencies).

## DOWNLOAD

knife cookbook site download COOKBOOK [VERSION] (options)

`-f`, `--file FILE`
  The filename to write to
`--force`
  Force download deprecated cookbook

Downloads a specific cookbook from the Community site, optionally specifying a certain version.

## LIST

knife cookbook site list (options)

`-w`, `--with-uri`
  Show corresponding URIs

Lists available cookbooks from the Community site.

## SEARCH

knife cookbook site search QUERY (options)

Searches for available cookbooks matching the specified query.

## SHARE

knife cookbook site share COOKBOOK CATEGORY (options)

`-k`, `--key KEY`
  API Client Key
`-u`, `--user USER`
  API Client Username
`-o`, `--cookbook-path PATH:PATH`
  A colon-separated path to look for cookbooks in

Uploads the specified cookbook using the given category to the Opscode cookbooks site. Requires a login user and certificate for the Opscode Cookbooks site. By default, knife will use the username and API key you've configured in your configuration file; otherwise you must explicitly set these values on the command line or use an alternate configuration file.

## UNSHARE

knife cookbook site unshare COOKBOOK

Stops sharing the specified cookbook on the Opscode cookbooks site.

## SHOW

knife cookbook site show COOKBOOK [VERSION] (options)

Shows information from the site about a particular cookbook.

## DESCRIPTION

The cookbook site, http://community.opscode.com/, is a cookbook distribution service operated by Opscode. This service provides users with a central location to publish cookbooks for sharing with other community members.

`knife cookbook site` commands provide an interface to the cookbook site's HTTP API. For commands that read data from the API, no account is required. In order to upload cookbooks using the `knife cookbook site share` command, you must create an account on the cookbook site and configure your credentials via command line option or in your knife configuration file.

## EXAMPLES

Uploading cookbooks to the Opscode cookbooks site:

    knife cookbook site share example Other -k ~/.chef/USERNAME.pem -u USERNAME

## SEE ALSO

knife-cookbook(1) http://community.opscode.com/cookbooks

## AUTHOR

Chef was written by Adam Jacob adam@opscode.com with many contributions from the community.

## DOCUMENTATION

This manual page was written by Joshua Timberman joshua@opscode.com. Permission is granted to copy, distribute and / or modify this document under the terms of the Apache 2.0 License.

## CHEF

Knife is distributed with Chef. http://wiki.opscode.com/display/chef/Home

1. Chef 11.4.4
2. April 2013
3. knife-cookbook-site(1)